package prupp;

// $Id: ClearCache.java,v 1.7 1998/12/19 13:46:09 d94-rol Exp $

import java.io.*;
import java.net.*;
import java.util.Properties;

/** Clears the cache on all files that are in it.
 */
public class ClearCache implements MetaHandler {
    /** default constructor */
    public ClearCache () {
    }

    /** handler of a MetaPage.
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param url the requested url.
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param uap the username and paswword as by Basic-authentication
     */
    public void handle (DataInputStream input, DataOutputStream output, URL url, Properties htab, String uap) {
	try {
	    StringBuffer res = new StringBuffer (Proxy.getHeader ().toString() + 
						 HTMLPage.getPageHeader ("Removing all files in the cache directory."));
	    res.append ("Please be patient....<br>");
	    output.write (res.toString ().getBytes ());
	    Proxy.getCache ().clear ();
	    output.write (("<font color=\"blue\">done!</font></body></html>\n").getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write cache-cleared message to client");
	} 
	return;    
    }  
}
