package prupp;

// $Id: Util.java,v 1.3 1998/12/19 13:46:10 d94-rol Exp $
// $Author: d94-rol $
// $Date: 1998/12/19 13:46:10 $

/** this class is inteded to do stuff that I dont want to do elsewhere
 *  and it may be useful
 */
public class Util {
  
    /** constructor
     */
    public Util () {
	// nah.
    }
  
    /** the base64 characters 
     */
    private static final int pr2six[] = {
	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,62,64,64,64,63,
	52,53,54,55,56,57,58,59,60,61,64,64,64,64,64,64,64,0,1,2,3,4,5,6,7,8,9,
	10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,64,64,64,64,64,64,26,27,
	28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,
	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,
	64,64,64,64,64,64,64,64,64,64,64,64,64
    };

    /** uudecode the given string.
     *  useful for decoding basic Authentication 
     */
    public static String uudecode (String base64string) {
	StringBuffer ret = new StringBuffer ();
    
	while ((base64string.length () % 4) != 0)
	    base64string += "=";           // that should be safe.
	int i = 0;
	int c1 = 0, c2 = 0, c3 = 0, c4 = 0;
	while (i < base64string.length () && pr2six[base64string.charAt (i)] <= 63) {
	    c1 = pr2six[base64string.charAt (i)];
	    c2 = pr2six[base64string.charAt (i+1)];
	    c3 = pr2six[base64string.charAt (i+2)];
	    c4 = pr2six[base64string.charAt (i+3)];
	    ret.append ((char)(c1 << 2 | c2 >> 4));
	    ret.append ((char)((c2 << 4 | c3 >> 2) % 256));
	    ret.append ((char)((c3 << 6 | c4) % 256));      
	    i += 4;
	}    
    
	if (c3 > 63)
	    ret.setLength (ret.length () - 2);
	else if (c4 > 63)
	    ret.setLength (ret.length () - 1);
	return ret.toString ();;
    }

    /** URLDecode a string. This is useful when your handling CGI-arguments..
     * @param enc the encoded String.
     * @return an unescaped String. ('%dd' => 'c', '+' => ' ')
     */
    public static String URLdecode (String enc) {
	enc = enc.replace ('+', ' ');
	int i = 0;
	while (true) {
	    i = enc.indexOf ('%', i);
	    if (i < 0) 
		break;
	    try {
		char c = (char) Integer.parseInt (enc.substring (i+1,i+3), 16);
		enc = enc.substring (0, i) + c + enc.substring (i+3);
	    } catch (NumberFormatException e) {
		// ignore
	    }
	}
	return enc;
    }
}
